%{
#include <stdio.h>
#include <ctype.h>
#include "ics.h"
#include "ashcurseshack.h"

extern int  TV(), modif(), dec_oct(), oct_dec(), dec(), isoctcode();
extern int  eflag;
extern      dump(), exec(), mess();
int         octcode[29] = {
    0, 1, 2, 3, 4, 5, 6, 7, 10, 11, 12, 13, 14, 15, 16, 17, 20, 21,
    24, 25, 27, 30, 31, 32, 33 ,34, 35, 36, 37};
/* 
int         store[1029], isorder[1025];
*/
extern int store(), save();
int         SCR = 0, reg_A = 0, reg_B = 0, reg_x = 0;
int         N = 0, Z = 0, V = 0;
int         traceflag = 0;
int         maxorders = 100;
int         maxcount = 0;
int         execflag = 0;
%}
%union {
	int s;
	int I;
}

%token<I> CODE	CHAR
%token<I> RESS	ORDS
%token<I> ADD     MODE    DIGS
%token<I> NEGNO   POSNO   PAKNO
%token<I> LDAsym  LDXsym  STAsym
%token<I> STXsym  ADAsym  ADXsym
%token<I> SBAsym  SBXsym  CPAsym
%token<I> CPXsym  ANAsym  ANXsym
%token<I> ORAsym  ORXsym  NTAsym
%token<I> NTXsym  SLLsym  SLRsym
%token<I> MPYsym  DIVsym  EXCsym
%token<I> JCPsym  JCNsym  JCZsym
%token<I> JCVsym  JMPsym  SBRsym
%token<I> DXTsym  ERRsym  HLTsym
%token<I> END

%type<I> order data
%type<I> address addend
%type<I> chars oct
%nonassoc '%'

%start prog

%%
prog		:statseq
		|
		;

statseq		:statseq stat ';'
			{if(execflag==4) exec();
			  printf("	:: ");execflag=0;}
		|error ';'
			{yyerrok;printf("	:: ");}
		|ERRsym error ';'
			{yyerrok;printf("	:: ");}
		|statseq error ';'
			{yyerrok;printf("	:: ");}
		|statseq ERRsym error ';'
			{yyerrok;printf("	:: ");}
		| stat ';'
			{if(execflag==4) exec();
			printf("	:: ");execflag=0;}
		| statseq END ';'
			{ return 0; }
		| END ';' /* Ash fix May 2002 */
			{ return 0; }
		;

stat		:'?'
			{traceflag = 1 - traceflag;}
		|'*'
			{printf("...EXIT ICS  \n");exit(0);}
		|ORDS
			{maxorders = $1;}
		|'>' address
			{if(eflag==0)
				{SCR = $2;execflag=4;} else 
			mess(eflag);}
		|'#' address addend 
			{if(eflag==0)
				dump($2,$3);
                                   else mess(eflag);}
		|'@' address
			{if(eflag==0) SCR = $2; else mess(eflag);}
		|data
			{if((SCR <0 ) || (SCR > 1024)) eflag=6;
                         if(eflag == 0)
				{save(SCR++, TV($1));}
                         else mess(eflag);}
		|order
			{ if((SCR < 0) || (SCR > 1024)) eflag=6; 
			if(eflag==0)
				{save(SCR++, $1);} 
			else mess(eflag);}
		|
		;

order		:chars MODE oct
			{if($2 >= 4)
				eflag=2;
			$$ = dec($1,$2,oct_dec($3,2));}
		|chars
			{$$=dec($1,NLL,NLL);}
		|chars oct
			{$$ = dec($1,NLL,oct_dec($2,2));}
		| chars MODE MODE
			{if( ($3<0) || ($3>7) ) eflag=3;
			$$ = dec($1,$2,$3);}
		|chars MODE CODE
			{if( ($3/10 > 7) || ($3%10 > 7 ) ) eflag=3;
			$$ = dec($1,$2,oct_dec($3,1));}
		|chars MODE
			{if( ($2 < 0) || ($2 > 7) ) eflag=3;
			$$= dec($1,NLL,$2);}
		|chars CODE
			{if( ($2/10 >7) || ($2%10 > 7) ) eflag=3;
			$$ = dec($1,NLL,oct_dec($2,1));}
		;

address		:ADD oct
			{if(($1<0) || ($1>2))
			eflag=4;
			$$ = oct_dec($2,2) + ($1*PAG);}
		;

addend		:RESS oct
			{if(($1 < 0) || ($1 > 2))
			eflag=4;
			$$ = oct_dec($2,2) + ($1*PAG);}
		;

oct		:DIGS
			{$$ = $1; }
		;

data		:NEGNO
			{if($1 < -32765) eflag=7;
			$$=$1;}
		|POSNO
			{if($1 > 32767) eflag=7;
			$$=$1; }
		|PAKNO
			{$$=$1; }
		;

chars		: CODE
			{if((isoctcode($1))==false)
			eflag=5;
			$$ =oct_dec($1,1);}
		| CHAR
			{eflag=1; $$=0; }
		| LDAsym
			{$$ = LDAoct;}
		| LDXsym
			{$$ = LDXoct;}
		| STAsym
			{$$ = STAoct;}
		| STXsym
			{$$ = STXoct;}
		| ADAsym
			{$$ = ADAoct;}
		| ADXsym
			{$$ = ADXoct;}
		| SBAsym
			{$$ = SBAoct;}
		| SBXsym
			{$$ = SBXoct;}
		| CPAsym
			{$$ = CPAoct;}
		| CPXsym
			{$$ = CPXoct; }
		| ANAsym
			{$$ = ANAoct;}
		| ANXsym
			{$$ = ANXoct;}
		| ORAsym
			{$$ = ORAoct;}
		| ORXsym
			{$$ = ORXoct;}
		| NTAsym
			{$$ = NTAoct;}
		| NTXsym
			{$$ = NTXoct;}
		| SLLsym
			{$$ = SLLoct;}
		| SLRsym
			{$$ = SLRoct;}
		| MPYsym
			{$$ = MPYoct;}
		| DIVsym
			{$$ = DIVoct;}
		| EXCsym
			{$$ = EXCoct;}
		| JCPsym
			{$$ = JCPoct;}
		| JCNsym
			{$$ = JCNoct;}
		| JCZsym
			{$$ = JCZoct;} 
		| JCVsym
			{$$ = JCVoct;}
		| JMPsym
			{$$ = JMPoct;}
		| SBRsym
			{$$ = SBRoct;} 
		| DXTsym
			{$$ = DXToct;}
		| HLTsym
			{$$ = HLToct;}
		;
%%
yyerror(s)
    char       *s;
{
    fprintf(stderr, "%s\n", s);
}

ics3wrap()
{
	return 1;
}

ics3main()
{
    printf("ENTER ICS3 \n");
    printf("          :: ");
    return (ics3parse());
}
