%{
#include "ics.h"
#include "ics3gram.tab.h"
#include "ashcurseshack.h"
int eflag=0;
%}
	YYSTYPE ics3lval;
C	[A-Z]
D	[0-9]
Q	["]
pack	{C}{C}{C}
space	[ \t]
car	[\n]
directive   [#*@?>]

%%
	int k,tmp;
LDA	{ECHO; return(LDAsym);}
LDX	{ECHO; return(LDXsym);}
STA	{ECHO; return(STAsym);}
STX	{ECHO; return(STXsym);}
ADA	{ECHO; return(ADAsym);}
ADX	{ECHO; return(ADXsym);}
SBA	{ECHO; return(SBAsym);}
SBX	{ECHO; return(SBXsym);}
CPA	{ECHO; return(CPAsym);}
CPX	{ECHO; return(CPXsym);}
ANA	{ECHO; return(ANAsym);}
ANX	{ECHO; return(ANXsym);}
ORA	{ECHO; return(ORAsym);}
ORX	{ECHO; return(ORXsym);}
NTA	{ECHO; return(NTAsym);}
NTX	{ECHO; return(NTXsym);}
SLL	{ECHO; return(SLLsym);}
SLR	{ECHO; return(SLRsym);}
MPY	{ECHO; return(MPYsym);}
DIV	{ECHO; return(DIVsym);}
EXC	{ECHO; return(EXCsym);}
JCP	{ECHO; return(JCPsym);}
JCN	{ECHO; return(JCNsym);}
JCZ	{ECHO; return(JCZsym);}
JCV	{ECHO; return(JCVsym);}
JMP	{ECHO; return(JMPsym);}
SBR	{ECHO; return(SBRsym);}
DXT	{ECHO; return(DXTsym);}
HLT	{ECHO; return(HLTsym);}
END	{ECHO; return(END);}

{space}		ECHO;
"~"[^~\n]*	ECHO;
{pack}		{ECHO; return(CHAR); }
{car}		{ECHO;
			ics3text[0] = ';';
			return(ics3text[0]);
		}
{directive}	{ECHO;return(ics3text[0]);}
{D}":"		{ECHO;
			ics3lval.I = (ics3text[0] - '0');
			return(ADD) ;
		}

"-"{D}":"	{ECHO;
			ics3lval.I = (ics3text[1] - '0');
			return(RESS);
		}

"%"{D}*		{ECHO;
			ics3lval.I=0;
			for (k=1; k < ics3leng; k++) {
				ics3lval.I=10*ics3lval.I + (ics3text[k] - '0');
			}
			return ( ORDS );
		}

"+"{D}*		{ECHO;
			ics3lval.I=0;
			for (k=1; k<ics3leng; k++ ) {
				ics3lval.I=10*ics3lval.I + (ics3text[k] - '0');
			}
			return(POSNO);
		}

"-"{D}*		{ECHO;
			ics3lval.I=0;
			for (k=1; k<ics3leng; k++) { 
				ics3lval.I=10*ics3lval.I + (ics3text[k] - '0');
			}
			ics3lval.I = ics3lval.I * (-1); 
			return(NEGNO);
		}

{D}{D}{D}	{ECHO;
			ics3lval.I=0;tmp=0;
			for(k=0;k<ics3leng;k++) { 
				ics3lval.I=10*ics3lval.I + (ics3text[k]-'0'); 
				if(ics3text[k]-'0' >7)
					tmp=1;
			}
			if(tmp==1)
				eflag=3; 
			return(DIGS);
		}

{D}{D}		{ECHO;
			ics3lval.I=0;
			for(k=0;k<ics3leng;k++)    {
				ics3lval.I=10*ics3lval.I + (ics3text[k]-'0');
			}
			return(CODE);
		}

{D}		{ECHO;
			ics3lval.I = (ics3text[0] - '0');
			return(MODE);
		}

{Q}{C}{C}{Q}	{ECHO;
			ics3lval.I =(ics3text[1]*256 + ics3text[2]); 
			return(PAKNO);
		}

.		{ECHO; return(ERRsym);}
